@echo off

set PWD=%CD%

set INSTDIR=%~dp0..

set ERROR=

echo XMLFLAT_HIERACHICAL_MODELLING
cd %INSTDIR%\examples\xmlflat\hierachical_modelling
"%INSTDIR%\bin\mbsimflatxml.exe" MBS.mbsimprj.flat.xml
if ERRORLEVEL 1 set ERROR=%ERROR% XMLFLAT_HIERACHICAL_MODELLING
echo DONE

echo XML_HIERACHICAL_MODELLING
cd %INSTDIR%\examples\xml\hierachical_modelling
"%INSTDIR%\bin\mbsimxml.exe" MBS.mbsimprj.xml
if ERRORLEVEL 1 set ERROR=%ERROR% XML_HIERACHICAL_MODELLING
echo DONE

echo XML_TIME_DEPENDENT_KINEMATICS
cd %INSTDIR%\examples\xml\time_dependent_kinematics
"%INSTDIR%\bin\mbsimxml.exe" MBS.mbsimprj.xml
if ERRORLEVEL 1 set ERROR=%ERROR% XML_TIME_DEPENDENT_KINEMATICS
echo DONE

echo XML_HYDRAULICS_BALLCHECKVALVE
cd %INSTDIR%\examples\xml\hydraulics_ballcheckvalve
"%INSTDIR%\bin\mbsimxml.exe" MBS.mbsimprj.xml
if ERRORLEVEL 1 set ERROR=%ERROR% XML_HYDRAULICS_BALLCHECKVALVE
echo DONE


set OPENMBVCPPINTERFACE_PREFIX=%INSTDIR%

echo OPENMBVCPPINTERFACE_SWIG_OCTAVE
cd %INSTDIR%\share\openmbvcppinterface\examples\swig
%INSTDIR%\bin\octave.exe octavetest.m
if ERRORLEVEL 1 set ERROR=%ERROR% OPENMBVCPPINTERFACE_SWIG_OCTAVE
echo DONE

IF "%MBSIMENV_TEST_PYTHON%"=="1" (
  echo OPENMBVCPPINTERFACE_SWIG_PYTHON
  cd %INSTDIR%\share\openmbvcppinterface\examples\swig
  python pythontest.py
  if ERRORLEVEL 1 set ERROR=%ERROR% OPENMBVCPPINTERFACE_SWIG_PYTHON
  echo DONE
)

IF "%MBSIMENV_TEST_JAVA%"=="1" (
  echo OPENMBVCPPINTERFACE_SWIG_JAVA
  cd %INSTDIR%\share\openmbvcppinterface\examples\swig
  java -classpath .;%INSTDIR%/bin/openmbv.jar javatest
  if ERRORLEVEL 1 set ERROR=%ERROR% OPENMBVCPPINTERFACE_SWIG_JAVA
  echo DONE
)


echo H5PLOTSERIE
cd %INSTDIR%\examples\xml\hierachical_modelling
"%INSTDIR%\bin\h5plotserie.exe" TS.mbsim.h5
if ERRORLEVEL 1 set ERROR=%ERROR% H5PLOTSERIE
echo DONE

echo OPENMBV
cd %INSTDIR%\examples\xml\hierachical_modelling
"%INSTDIR%\bin\openmbv.exe" TS.ombv.xml
if ERRORLEVEL 1 set ERROR=%ERROR% OPENMBV
echo DONE

echo MBSIMGUI
"%INSTDIR%\bin\mbsimgui.exe"
if ERRORLEVEL 1 set ERROR=%ERROR% MBSIMGUI
echo DONE

if "%ERROR%"=="" (
  echo ALL TESTS PASSED
) else (
  echo THE FOLLOWING TESTS FAILED:
  echo %ERROR%
)

cd "%PWD%"