/*
    OpenMBV - Open Multi Body Viewer.
    Copyright (C) 2009 Markus Friedrich

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _OPENMBVGUI_SOTRANSPOSEENGINE_H_
#define _OPENMBVGUI_SOTRANSPOSEENGINE_H_

#pragma push_macro("NDEBUG") // reworkaround some debugging bug in Coin3D
#ifndef NDEBUG
#define NDEBUG
#endif
#include <Inventor/engines/SoSubEngine.h>
#include <Inventor/fields/SoSFRotation.h>
#pragma pop_macro("NDEBUG")

namespace OpenMBVGUI {

class SoTransposeEngine : public SoEngine {
 SO_ENGINE_HEADER(SoTransposeEngine);
 public:
   SoSFRotation inRotation; // input
   SoEngineOutput outRotation; // output (SoSFRotation)

   static void initClass();
   SoTransposeEngine();

 private:
   virtual ~SoTransposeEngine() {}
   virtual void evaluate();
};

}

#endif
